async function fetch_request(url){
     console.log('fetch url');
     console.log(url);
     var shangjia_infos = [];
     let options = {
         method: 'get',
         headers: {
             'Content-Type':'application/json;charset=utf-8'
         },
         // body: JSON.stringify(res)
     }
     // Fake api for making post requests
    //console.log('fetch_request url:'+url);
    await fetch(url,options).then(res =>
        res.json()).then(d => {
            console.log('fetch response:');
            console.log(d);
            if(d){
                let companyWithOfferLists = d['data']['data']['companyWithOfferLists'];
                for (let _f=0;_f<companyWithOfferLists.length;_f++){
                    let _factoryInfo = companyWithOfferLists[_f]['factoryInfo'];
                    shangjia_infos.push({
                        '_shangjia_name': _factoryInfo['company'],
                        '_shangjia_company_type':_factoryInfo['isFactory']=='Y'?'工厂':'非工厂',
                        '_shangjia_business': _factoryInfo['recommendWords'].join(','),
                        '_shangjia_product': _factoryInfo['productionService'],
                        '_shangjia_city':_factoryInfo['city'],
                        '_shangjia_a_link': _factoryInfo['factoryDetailUrl'],
                    });
                }
            }
            //
        })
    return shangjia_infos;
}

function util_replaceFirstLetter(inputString, newFirstLetter) {
  if (inputString.length === 0) {
    return newFirstLetter;
  }
  return newFirstLetter + inputString.slice(1);
}
//
function util_get_supplierId(url = ''){
    //https://www.globalsources.com/api/web/bff/supplier/v1/contact-number?supplierId=6008849965481
    //https://inzok.manufacturer.globalsources.com/company-profile_6008849965481.htm
    let _url = url.replace('.htm','');
    let _url_arr = _url.split('company-profile_');
    if(_url_arr.length == 2){
        let _supplierId = _url_arr[1];
        _supplierId = util_replaceFirstLetter(_supplierId,2);
        return _supplierId;
    }
    return '';
}
//catalog product
//catalog supplier list
//searchList/products
//
function shangjia_catalog_product_caiji(){
    let current_url = window.location.href;
    if(current_url) {
        if (current_url.indexOf('category') != -1 || current_url.indexOf('searchList') != -1) {
            var shangjia_infos = [];
            console.log('shangjia_catalog_product_caiji a2');
            //catalog product list
            $(".product-list li").each(function (){
                console.log('shangjia_catalog_product_caiji a3');
                let _shangjia_name = '';
                let _shangjia_contact_info_url = '';
                let _shangjia_business = '';
                let _shangjia_product = '';
                let _shangjia_company_type = '';
                let _shangjia_city = '';
                //
                let _shangjia_a_link = $(this).find('.name a').attr('href');
                if(_shangjia_a_link){
                    _shangjia_a_link = _shangjia_a_link.replace('homepage','company-profile').replace('//','https://');
                    let _shangjia_id = _shangjia_a_link;
                    //
                    _shangjia_name = $(this).find('.name a').text();
                    _shangjia_name = _shangjia_name.trim();
                    //
                    let _shangjia_get_supply_phone_url = '';
                    let _supplierId = util_get_supplierId(_shangjia_a_link);
                    if(_supplierId){
                        _shangjia_get_supply_phone_url = 'https://www.globalsources.com/api/web/bff/supplier/v1/contact-number?supplierId='+_supplierId;
                    }
                    //
                    let _shangjia_info = {
                        '_shangjia_id': _shangjia_id,
                        '_shangjia_a_link':_shangjia_a_link,
                        '_shangjia_name': _shangjia_name,
                        '_shangjia_get_supply_phone_url': _shangjia_get_supply_phone_url
                    };
                    //console.log(_shangjia_info);
                    shangjia_infos.push(_shangjia_info);
                    //
                }
            });
            //supplier-list,Exhibitors
            $("ul.supplier-list li").each(function (){
                console.log('shangjia_catalog_product_caiji supplier-list a3');
                let _shangjia_name = '';
                let _shangjia_contact_info_url = '';
                let _shangjia_business = '';
                let _shangjia_product = '';
                let _shangjia_company_type = '';
                let _shangjia_city = '';
                //
                let _shangjia_a_link = $(this).find('.mod-supp-info a:eq(0)').attr('href');
                if(_shangjia_a_link){
                    _shangjia_a_link = _shangjia_a_link.replace('homepage','company-profile').replace('//','https://');
                    let _shangjia_id = _shangjia_a_link;
                    //
                    _shangjia_name = $(this).find('h2').text();
                    _shangjia_name = _shangjia_name.trim();
                    //
                    let _shangjia_get_supply_phone_url = '';
                    let _supplierId = util_get_supplierId(_shangjia_a_link);
                    if(_supplierId){
                        _shangjia_get_supply_phone_url = 'https://www.globalsources.com/api/web/bff/supplier/v1/contact-number?supplierId='+_supplierId;
                    }
                    //
                    let _shangjia_info = {
                        '_shangjia_id': _shangjia_id,
                        '_shangjia_a_link':_shangjia_a_link,
                        '_shangjia_name': _shangjia_name,
                        '_shangjia_get_supply_phone_url': _shangjia_get_supply_phone_url
                    };
                    //console.log(_shangjia_info);
                    shangjia_infos.push(_shangjia_info);
                    //
                }
            });
            //
            var message = {
                action: 'shangjia_items_update',
                info: '',
                shangjia_infos: shangjia_infos
            };
            send_message_to_popup(message);
        }
    }
}

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'xmlhttprequest'){
            //search product list
            if(performanceResourceItem['name'].indexOf('api/agg-search/DESKTOP/v3/product/search')!=-1 ||
                performanceResourceItem['name'].indexOf('api/agg-search/DESKTOP/v3/supplier/search') != -1
            ) {
                //console.log(performanceResourceItem['name']);
                console.log('bbbb' + performanceResourceItem['name']);
                //
                setTimeout(function () {
                    shangjia_catalog_product_caiji();
                }, 1000);
            }
        }
    }
    //////
    /*performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }*/
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
observer_.observe({entryTypes:['resource', 'navigation', 'paint']});
//

$(document).ready(function () {
    let current_url = window.location.href;
    if(current_url) {
        if (current_url.indexOf('category') != -1 || current_url.indexOf('searchList') != -1) {
            setTimeout(function() {
                    shangjia_catalog_product_caiji();
                }, 1000);
        }
    }
});

//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}
//
function downloadIamge(imgsrc, name){//下载图片地址和图片名
    let image = new Image();
    // 解决跨域 Canvas 污染问题
    image.setAttribute("crossOrigin", "anonymous");
    image.onload = function() {
        let canvas = document.createElement("canvas");
        canvas.width = image.width;
        canvas.height = image.height;
        let context = canvas.getContext("2d");
        context.drawImage(image, 0, 0, image.width, image.height);
        let url = canvas.toDataURL("image/jpeg"); //得到图片的base64编码数据
        let a = document.createElement("a"); // 生成一个a元素
        let event = new MouseEvent("click"); // 创建一个单击事件
        a.download = name || "photo"; // 设置图片名称
        a.href = url; // 将生成的URL设置为a.href属性
        a.dispatchEvent(event); // 触发a的单击事件
    }
    image.src = imgsrc;
}
//
function get_product_lunbo_imgs(){
    console.log('aaaa');
    //图片列表
    $('._2AOclWz7 ._3ACovDZO').each(function (){
        var _img = $(this).find('img').attr('src');
        if(_img.indexOf("?") !== -1){
            var _imgarr = _img.split('?')
            _img = _imgarr[0];
            //
            _img_src = _img;
            var _imgarr = _img.split('/')
            _img_name = _imgarr[_imgarr.length-1]
            _img_name_arr = _img_name.split('.')
            _img_name = _img_name_arr[0]
            //
            downloadIamge(_img_src,_img_name);
        }

    })
    //
}
//
function get_product_details_imgs(){
    console.log('aaaa');
    //
    $('._151rnt-L').find('img').each(function (){
        var _detail_img = $(this).attr('src');
        if(_detail_img.indexOf("?") !== -1){
            var _detail_imgarr = _detail_img.split('?')
            _detail_img = _detail_imgarr[0];
            //
            _img_src = _detail_img;
            var _imgarr = _detail_img.split('/')
            _img_name = _imgarr[_imgarr.length-1]
            _img_name_arr = _img_name.split('.')
            _img_name = _img_name_arr[0]
            //
            downloadIamge(_img_src,_img_name);
        }

    })

}
//
// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if(request.action == 'extract-product-lunbo-imgs'){
        console.log(request.info);
        catalog_products_url = get_product_lunbo_imgs();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract-product-details-imgs'){
        console.log(request.info);
        catalog_products_url = get_product_details_imgs();
        sendResponse(catalog_products_url);
    }
})
//